﻿Imports System.Windows.Threading

Public Class DispatchService
    Private ReadOnly _dispatcher As Dispatcher

    Public Sub New(ByVal dispatcher As Dispatcher)
        _dispatcher = dispatcher
    End Sub

    Public Function CheckAccess() As Boolean
        Return _dispatcher.CheckAccess()
    End Function

    Public Sub BeginInvoke(ByVal method As [Delegate], ByVal ParamArray args As Object())
        SyncLock _dispatcher
            _dispatcher.BeginInvoke(method, args)
        End SyncLock
    End Sub
    Public Sub Invoke(ByVal method As [Delegate], ByVal ParamArray args As Object())
        SyncLock _dispatcher
            _dispatcher.Invoke(method, args)
        End SyncLock
    End Sub

End Class
